/*======================================证件照制作接口======================================*/
package main

import (
	"bytes"
	"crypto/md5"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"log"
	"net/http"
)

func ImgtoBase64(filePath string) string {
	//图片转Base64
	bytes, err := ioutil.ReadFile(filePath)
	if err != nil {
		log.Fatal(err)
	}
	var base64Encoding string
	base64Encoding += base64.StdEncoding.EncodeToString(bytes)
	return base64Encoding
}

func MD5(v string) string {
	d := []byte(v)
	m := md5.New()
	m.Write(d)
	b := m.Sum(nil)
	return base64.StdEncoding.EncodeToString([]byte(b))
}

const (
	appCode    = "你的appcode"
	IdphotoUrl = "https://idp2.market.alicloudapi.com/idphoto/make"
)

func main() {

	client := &http.Client{}
	data := make(map[string]interface{})
	data["type"] = "jpg"
	data["photo"] = ImgtoBase64("1.jpg")
	data["spec"] = "1" // 见证件照规格列表
	data["bk"] = "red" //见证件照颜色列表
	data["with_photo_key"] = 1 //是否返回photo_key
	//data["beauty_degree"] = 1.5 //可选参数，美颜级别，浮点型，取值[1.0-5.0]，超出范围后的值无效。主要调节了脸部黑白平衡。

	bytesData, _ := json.Marshal(data)
	req, _ := http.NewRequest("POST", IdphotoUrl, bytes.NewReader(bytesData))
	req.Header.Set("Content-Type", "application/json")
	req.Header.Set("Authorization", "APPCODE "+appCode)

	md5Str := MD5(string(bytesData))
	req.Header.Set("Content-MD5", md5Str)

	resp, _ := client.Do(req)
	fmt.Println(resp.Header)
	fmt.Println(resp.Header["X-Ca-Error-Message"])
	body, _ := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))

}
